unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Menus, ImgList, CoolTrayIcon, Unit2,
  IdBaseComponent, IdComponent, IdRawBase, IdRawClient, IdIcmpClient,
  IdAntiFreezeBase, IdAntiFreeze;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    CoolTrayIcon1: TCoolTrayIcon;
    ImageList1: TImageList;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Show1: TMenuItem;
    Hide1: TMenuItem;
    icmp: TIdIcmpClient;
    Timer1: TTimer;
    IdAntiFreeze1: TIdAntiFreeze;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    sent: TLabeledEdit;
    received: TLabeledEdit;
    lost: TLabeledEdit;
    minimum: TLabeledEdit;
    maximum: TLabeledEdit;
    avarage: TLabeledEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure icmpReply(ASender: TComponent;
      const AReplyStatus: TReplyStatus);
    procedure Show1Click(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
//    thread:Ping;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const tostring1:array[TReplyStatusTypes] of string=('An echo was received.',
                                                    'An error has occured.',
                                                    'TimeOut',
                                                    'Host unreachable',
                                                    'Time-To-Live exceeded');

procedure TForm1.FormCreate(Sender: TObject);
begin
//  thread:=Ping.Create(2000,self);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//  thread.Terminate;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  timer1.enabled:=false;
  if memo1.Lines.Count>10 then memo1.Lines.Clear;
  icmp.Host:=edit1.text;
  icmp.Ping('ciuly');
  sent.Text:=inttostr(strtoint(sent.text)+1);
end;

function tostring(status:TReplyStatus):string;
begin
  result:=tostring1[status.ReplyStatusType];
end;

procedure TForm1.icmpReply(ASender: TComponent;
  const AReplyStatus: TReplyStatus);
var a,s:cardinal;
begin
  memo1.lines.add('reply from '+icmp.Host+' : '+tostring(AReplyStatus));
  if AReplyStatus.ReplyStatusType=rsEcho then
  begin
    CoolTrayIcon1.IconIndex:=1;
    received.Text:=inttostr(strtoint(received.text)+1);
    if strtoint(minimum.text)>icmp.ReplyStatus.MsRoundTripTime then
      minimum.text:=inttostr(icmp.ReplyStatus.MsRoundTripTime);
    if strtoint(maximum.text)<icmp.ReplyStatus.MsRoundTripTime then
      maximum.text:=inttostr(icmp.ReplyStatus.MsRoundTripTime);
    s:=strtoint(sent.text);
    a:=strtoint(avarage.text);
    avarage.Text:=inttostr(round((s*a+icmp.ReplyStatus.MsRoundTripTime)/(s+1)));
  end                                    else
  begin
    CoolTrayIcon1.IconIndex:=0;
    lost.Text:=inttostr(strtoint(lost.text)+1);
  end;
  timer1.enabled:=true;
end;

procedure TForm1.Show1Click(Sender: TObject);
begin
  CoolTrayIcon1.ShowMainForm;
end;

procedure TForm1.Hide1Click(Sender: TObject);
begin
  CoolTrayIcon1.HideMainForm;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  close;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  timer1.Enabled:=false;
  edit1.enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  timer1.Enabled:=true;
  edit1.enabled:=false;
end;

end.
